# MoviePy आधारित मीडिया प्लेयर प्लगइन

कॉपीराइट 2010-2016 Daniel Schreij (<d.schreij@vu.nl>)

media_player_mpy प्लगइन [OpenSesame प्रयोग निर्माणकर्ता][opensesame] को वीडियो प्लेबैक क्षमताएं जोड़ता है। इस प्लगइन का आधार [Moviepy][mpy_home] है। इसे अधिकांश आधुनिक वीडियो और ऑडियो प्रारूपों को संभालने में सक्षम होना चाहिए, हालांकि महत्वपूर्ण है कि उनकी स्ट्रीम कोरप्ट नहीं होनी चाहिए। यदि कोई फ़ाइल काम नहीं कर रही है, तो देखें यदि आप बेहतर संस्करण ढूंढ सकते हैं, या इसे एक अलग प्रारूप में री-एन्कोड करने की कोशिश करें।

सर्वश्रेष्ठ प्लेबैक प्राप्त होगा जब हार्डवेयर एक्सिलेरेटेड Psychopy या Expyriment बैकएंड का उपयोग करें। प्रदर्शन शायद कम हो जब उपयोग कर रहे हों legacy और  मूवी का उच्च रेज़ोल्यूशन या फ्रेम रेट हो।

## प्लगिन सेटिंग्स
प्लगइन निम्नलिखित कॉन्फ़िगरेशन विकल्प GUI से प्रदान करता है:

- *वीडियो फ़ाइल* - वह वीडियो फ़ाइल जो चलानी है। इस फ़ील्ड में चर नोटेशन जैसे कि [video_file] की अनुमति होती है, जिसकी आप loop आइटम में मान निर्दिष्ट कर सकते हैं।
- *ऑडियो चलाएं* - विशेषता स्पष्ट करती है कि वीडियो को ऑडियो के साथ या मौन (म्यूट) में चलाना है।
- *वीडियो को स्क्रीन के आकार में फिट करें* - विशेषता यह स्पष्ट करती है कि वीडियो को उसके मूल आकार में चलाना चाहिए या खिड़की/स्क्रीन के आकर के अनुसार स्केल किया जाना चाहिए। पुनर्मापन प्रक्रिया मूवी के मूल aspect ratio को बनाए रखती है।
- *लूप* - यह स्पष्ट करती है कि वीडियो को लूप किया जाना चाहिए, यानी कि एक बार मूवी के अंत होने के बाद यह फिर से शुरू होगा।
- *अवधि* - यह स्पष्ट करता है कि मूवी को कितनी देर प्रदर्शित किया जाना चाहिए। एक मान की अपेक्षा करता है सेकंड में, 'keypress' या 'mouseclick' में। यदि इसके पास अंतिम मान है, तो प्लेबैक एक कुंजी को प्रेस किए जाने पर या माउस बटन क्लिक किए जाने पर रुक जाएगा।

## कस्टम Python कोड के हैंडलिंग keypress और mouseclick इवेंट्स
यह प्लगइन कस्टम इवेंट हैंडलिंग कोड को प्रत्येक frame के बाद, या key press या mouse click (नोट करें कि प्रत्येक frame के बाद कोड का निष्पादन 'keypress' option को nullify करता है अवधि क्षेत्र में; हालांकि Escape press को फिर भी सुना जाता है) के बाद निष्पादित करने की फ़ंक्शनलिटी भी प्रदान करता है। यह उदाहरण स्वरूप उपयोगी होता है, यदि कोई चाहता है कि गिने जाएं कि भागीदार ने स्थान (या किसी अन्य बटन) को मूवी के शोटाइम के दौरान कितनी बार प्रेस किया।

आपके पास यहां दर्ज की गई स्क्रिप्ट में कुछ चर हैं:

- `continue_playback` (सच या झूठ) - निर्धारित करता है कि मूवी को खेलना जारी रखना चाहिए। इस चर को डिफ़ॉल्ट रूप से सच के रूप में सेट किया जाता है जब मूवी चल रही होती है। यदि आप अपनी स्क्रिप्ट से प्लेबैक को रोकना चाहते हैं, तो बस इस चर को झूठ में सेट करें और प्लेबैक बंद हो जाएगा।
- `exp` - एक सुविधा चर जो self.experiment ऑब्जेक्ट की ओर सूचित करता है
- `frame` - जो वर्तमान frame प्रदर्शित किया जा रहा है उसका नंबर
- `mov_width` - मूवी की चौड़ाई px में
- `mov_height` - मूवी की ऊचाई px में
- `paused` - *सच* जब प्लेबैक वर्तमान में रोका गया हो, *झूठ* अगर मूवी वर्तमान में चल रही हो
- `event` - यह चर कुछ विशेष है, क्योंकि इसकी सामग्री निर्भर करती है कि क्या एक key या mouse button अंतिम frame के दौरान दबाया गया था। अगर ऐसा नहीं है, तो event चर बस *कोई नहीं* की ओर सूचित करेगा। यदि एक key दबाई गई थी, तो event पहली स्थिति में "key" मान और दूसरी स्थिति में उस key का मान यदि, उदाहरण स्वरूप ("key","space")। यदि mouse button क्लिक किया गया था, तो event चर पहली स्थिति में "mouse" मान और दूसरी स्थिति में mouse button की संख्या जो क्लिक की गई थी, उदाहरण स्वरूप ("mouse", 2)। यदि दुर्लभ अवसर में एक frame के दौरान समय-समय पर एकाधिक बटन या keys दबाए गए थे, तो event चर में इन इवेंट्स की सूची होगी, उदाहरण के लिए [("key","space"),("key", "x"),("mouse",2)]। इस मामले में, आपको अपने कोड में इस सूची को ट्रैवर्स करना होगा और सभी इवेंट्स को बाहर निकालना होगा जो आपके लिए महत्वपूर्ण हैं।

इन चरों के अलावा, आपके पास निम्नलिखित functions भी हैं:

- `pause()` - Pause the movie when it is running, and unpause it otherwise (you could consider it a pause/unpause toggle)

[opensesame]: http://www.cogsci.nl/opensesame
[mpy_home]: http://zulko.github.io/moviepy/