# MoviePyベースのメディアプレイヤープラグイン

著作権 2010-2016 Daniel Schreij (<d.schreij@vu.nl>)

media_player_mpyプラグインは、[OpenSesame実験ビルダー][opensesame]にビデオ再生機能を追加します。このプラグインは、[Moviepy][mpy_home] を基にしています。最新のビデオとオーディオ形式をほとんど取り扱えるはずですが、そのストリームが破損していないことが重要です。ファイルが動作しないように見える場合は、より良いバージョンを見つけるか、別の形式に再エンコードしてみてください。

最高の再生は、ハードウェアアクセラレーションを使ったPsychopyやExpyrimentバックエンドを使用することで達成されます。パフォーマンスはレガシーを使用したり、映画が高解像度またはフレームレートが高い場合には不足するかもしれません。

## プラグインの設定
プラグインはGUIから以下の設定オプションを提供します：

- *ビデオファイル* - 再生するビデオファイル。このフィールドは[video_file]のような可変表記を許可し、あなたはループアイテムでその値を指定することができます。
- *オーディオの再生* - ビデオがオーディオを伴って再生されるか、音声なし（ミュート）で再生されるかを指定します。
- *画面にビデオをフィット* - ビデオをオリジナルのサイズで再生するか、またはウィンドウ/画面のサイズにフィットするようにスケーリングする未指定します。このリスケーリング手順は、映画のオリジナルのアスペクト比を保持します。
- *ループ* - ビデオがループすべきかどうかを指定します。これは、映画の終わりに到達すると再び最初から始まることを意味します。
- *期間* - 映画を表示する期間を指定します。秒単位の値、'keypress'、'mouseclick'を期待しています。最後の値がある場合、キーが押された時やマウスボタンがクリックされた時に再生が停止します。

## キープレスとマウスクリックイベントを処理するためのカスタムPythonコード
このプラグインでは、各フレーム後、またはキープレスまたはマウスクリック後にカスタムイベント処理コードを実行する機能も提供します。（各フレーム後のコード実行は、期間フィールドの'keypress'オプションを無効にします；エスケープキーのプレスはまだリッスンされます）。これはたとえば、映画の上映時間中に参加者がスペースキー（または他のボタン）を何回押すかを数えたいときに便利です。

ここに入力するスクリプトでアクセスできるいくつかの変数があります：

- `continue_playback`（TrueまたはFalse） - 映画が再生し続けるべきか否かを決定します。この変数は映画が再生されている間、デフォルトでTrueに設定されています。あなたのスクリプトから再生を停止したい場合は、この変数をFalseに設定するだけで、再生は停止します。
- `exp` - 自己実験オブジェクトを指す便利な変数
- `frame` - 現在表示されているフレームの数字
- `mov_width` - 映画の幅（ピクセル）
- `mov_height` - 映画の高さ（ピクセル）
- `paused` - 再生が現在一時停止されている場合は*True*、映画が現在実行中の場合は*False*
- `event` - この変数は特別で、内容は最後のフレーム中にキーまたはマウスボタンが押されたかどうかに依存します。この場合でなければ、event変数は単純に*None*を指すことになります。キーが押された場合、eventは始めに"value"の値を、2番目に押されたキーの値を含むタプル、例えば("key","space")を含みます。マウスボタンがクリックされた場合、event変数は最初に位置に"mouse"の値、2番目にクリックされたマウスボタンの番号、例えば("mouse", 2)を含むタプルを含みます。1フレーム中に同時に複数のボタンやキーが押された稀な場合、event変数はこれらのイベントのリストを含みます。例えば、[("key","space"),("key", "x"),("mouse",2)]。この場合、コードでこのリストを走査し、関連するすべてのイベントを引き出す必要があります。

これらの変数に加えて、次の関数もご利用いただけます：

- `pause()` - 映画が実行中の場合は再生を一時停止し、それ以外の場合は再生を再開します（これを一時停止/再開トグルと見なすことができます）

[opensesame]: http://www.cogsci.nl/opensesame
[mpy_home]: http://zulko.github.io/moviepy/