# MoviePy 기반 미디어 플레이어 플러그인

저작권 2010-2016 Daniel Schreij (<d.schreij@vu.nl>)

media_player_mpy 플러그인은 [OpenSesame 실험 빌더][opensesame]에 비디오 재생 기능을 추가합니다. 이 플러그인은 [Moviepy][mpy_home]를 기반으로 사용합니다. 대부분의 현대 비디오 및 오디오 형식을 처리할 수 있어야하지만 그들의 스트림이 손상되지 않아야 합니다. 파일이 작동하지 않는 것처럼 보인다면, 더 좋은 버전을 찾아 보거나, 다른 형식으로 재인코딩해보세요.

하드웨어 가속 Psychopy 또는 Expyriment 백엔드를 사용하면 가장 좋은 재생을 얻을 수 있습니다. 레거시를 사용하고 영화의 해상도 또는 프레임 레이트가 높을 때 성능이 부족할 수 있습니다.

## 플러그인 설정
플러그인은 다음과 같은 설정 옵션을 GUI에서 제공합니다:

- *Video file* - 재생할 비디오 파일. 이 필드는 [video_file]과 같은 변수 표기를 허용하며, 루프 아이템에서 값을 지정할 수 있습니다.
- *Play audio* - 비디오를 오디오와 함께 재생할지, 무음(음소거)으로 재생할지를 지정합니다.
- *Fit video to screen* - 비디오를 원래 크기로 재생할지, 아니면 화면/스크린의 크기에 맞게 비디오를 재생할지를 지정합니다. 비디오 재조정 절차는 영화의 원래 측면 비율을 유지합니다.
- *Loop* - 비디오를 반복 재생할지 지정하며, 영화의 끝에 도달하면 다시 처음부터 시작한다는 것을 의미합니다.
- *Duration* - 영화가 표시되어야 하는 시간을 지정합니다. 초 단위의 값을 필요로하며, 'keypress' 또는 'mouseclick'이 가능합니다. 이중 하나라면, 키를 누르거나 마우스 버튼을 클릭할 때 재생이 중지됩니다.

## 키프레스와 마우스 클릭 이벤트를 처리하기 위한 사용자 정의 Python 코드
이 플러그인은 각 프레임 뒤, 또는 키 프레스 또는 마우스 클릭 후에 사용자 정의 이벤트 처리 코드를 실행하는 기능을 제공합니다(각 프레임 후의 코드 실행은 'keypress' 옵션을 duration 필드에서 무효화합니다; 그러나 Escape 프레스는 여전히 감지됩니다). 이것은 예를 들어 참가자가 영화의 시청 시간 동안 space(또는 다른 어떤 버튼)를 몇 번 누르는지 세는 데 유용합니다.

여기서 입력하는 스크립트에는 몇 가지 변수가 사용 가능합니다:

- `continue_playback` (True 또는 False) - 영화가 계속 플레이되어야 하는지 결정합니다. 이 변수는 영화가 플레이하는 동안 기본적으로 True로 설정됩니다. 스크립트에서 재생을 중지하려면, 이 변수를 False로 설정하면 재생이 중지됩니다.
- `exp` - 이는 self.experiment 객체를 가리키는 편리한 변수입니다.
- `frame` - 현재 표시되고 있는 프레임의 번호입니다.
- `mov_width` - 영화의 폭(픽셀 단위)
- `mov_height` - 영화의 높이(픽셀 단위)
- `paused` - 재생이 현재 일시 중지된 경우 *True*, 영화가 현재 실행 중인 경우 *False*
 
[next]: http://www.cogsci.nl/opensesame
[mpy_home]: http://zulko.github.io/moviepy/