# Плагин Media Player на основе MoviePy

Авторское право 2010-2016 Даниэль Шрей (<d.schreij@vu.nl>)

Плагин media_player_mpy добавляет возможности воспроизведения видео в [конструкторе эксперимента OpenSesame][opensesame]. Этот плагин использует [Moviepy][mpy_home] в качестве основы. Он должен поддерживать большинство современных видео- и аудиоформатов, хотя важно, чтобы их потоки не были повреждены. Если файл, похоже, не работает, посмотрите, не можете ли вы найти более качественную версию или попытайтесь перекодировать его в другой формат.

Лучшее воспроизведение будет достигнуто при использовании оборудованного ускорителем Psychopy или Expyriment backend. Производительность может быть недостаточной при использовании устаревшего и фильм имеет высокое разрешение или частоту кадров.

## Настройки плагина
Плагин предлагает следующие варианты конфигурации из графического интерфейса:

- *Видеофайл* - файл видео, который будет воспроизведен. Это поле позволяет использовать переменные обозначения, такие как [video_file] и определять их значение в цикле элементов.
- *Воспроизвести аудио* - определяет, должно ли видео воспроизводиться со звуком или без звука (отключенным).
- *Подогнать видео под экран* - определяет, должно ли видео быть воспроизведено в его оригинальном размере, или его следует масштабировать для соответствия размеру окна/экрана. Процедура изменения масштаба сохраняет оригинальное соотношение сторон видео.
- *Повтор* - определяет, должно ли видео быть зациклено, что означает, что оно начнется снова с начала, как только будет достигнут конец фильма.
- *Длительность* - Определяет, как долго должен отображаться фильм. Ожидает значение в секундах, 'keypress' или 'mouseclick'. Если значение одно из последних, воспроизведение остановится при нажатии клавиши или кнопки мыши.

## Пользовательский код Python для обработки событий нажатия клавиш и кликов мыши
Этот плагин также предлагает функциональность выполнения своего кода обработки событий после каждого кадра или после нажатия клавиши или клика мыши (Обратите внимание, что выполнение кода после каждого кадра отменяет опцию 'keypress' в поле длительности; нажатия Escape все же прослушиваются). Это, например, может быть полезно, если хочется подсчитать, сколько раз участник нажимает пробел (или любую другую кнопку) в течение времени показа фильма.

В скрипте, который вы вводите здесь, доступно несколько переменных:
 
- `continue_playback` (True или False) - Определяет, должен ли фильм продолжать воспроизводиться. Эта переменная по умолчанию устанавливается в True во время воспроизведения фильма. Если вы хотите остановить воспроизведение из своего скрипта, просто установите эту переменную в False, и воспроизведение остановится.
- `exp` - Вспомогательная переменная, указывающая на объект self.experiment
- `frame` - Номер текущего отображаемого кадра
- `mov_width` - Ширина фильма в пикселях
- `mov_height` - Высота фильма в пикселях
- `paused` - *True*, когда воспроизведение в данный момент приостановлено, *False*, если фильм в данный момент идет
- `event` - Эта переменная имеет некоторую особенность, так как ее содержание зависит от того, нажата ли кнопка или кнопка мыши во время последнего кадра. Если это не так, то переменная event просто указывает на *None*. Если кнопка была нажата, событие будет содержать кортеж со значением "ключ" на первой позиции и значением нажатой клавиши на второй позиции, например ("key","space"). Если была нажата кнопка мыши, переменная события будет содержать кортеж со значением "mouse" на первой позиции и номером нажатой кнопки мыши на второй позиции, например ("mouse", 2). В редком случае, когда несколько кнопок или клавиш были нажаты одновременно во время кадра, переменная события будет содержать список этих событий, например [("key","space"),("key", "x"),("mouse",2)]. В этом случае вам потребуется пройти по этому списку в своем коде и вытащить все события, которые вам интересны.

В дополнение к этим переменным у вас также есть следующие функции:

- `pause()` - Приостанавливает воспроизведение, когда фильм идет, и снимает паузу, если она стоит (можно рассматривать как переключатель паузы/воспроизведение)

[opensesame]: http://www.cogsci.nl/opensesame
[mpy_home]: http://zulko.github.io/moviepy/