# 基於 MoviePy 的 Media Player 插件

版權 2010-2016 Daniel Schreij (<d.schreij@vu.nl>)

media_player_mpy 插件為 [OpenSesame 實驗建立器][opensesame] 添加了視頻播放功能。此插件以 [Moviepy][mpy_home] 作為基礎。它應該能處理大部分現代視頻和音頻格式, 儘管重要的是他們的流不被破壞。如果一個文件不顯示為工作狀態, 看看你能否找到更好的版本, 或嘗試將其轉碼為其他格式。

通過使用硬體加速的 Psychopy 或 Expyriment 後端, 將獲得最佳播放效果。當使用遺留後端和電影擁有高解析度或幀率時, 效能可能會不足。

## 插件設定
該插件從 GUI 提供以下配置選項：

- *視頻文件* - 要播放的視頻文件。此欄位允許變量註釋, 例如 [video_file], 你可以在 loop 項目中指定其值。
- *播放音頻* - 指定視頻是否需要與音頻一起播放或靜音 (靜音)。
- *使視頻適應屏幕* - 指定視頻應以其原始大小播放, 或者應將其縮放以適應視窗/屏幕的大小。縮放程序保持電影的原始縱橫比。
- *循環* - 指定視頻是否應循環播放, 即一旦達到電影的結束, 它將再次從開始處開始。
- *期間* - 指定應顯示電影的時間長度。期待一個值以秒為單位, 'keypress' 或 'mouseclick'。如果有最後一個值, 當按下鍵或點擊滑鼠按鈕時, 播放將停止。

## 用於處理按鍵按壓和滑鼠點擊事件的自定義 Python 代碼
此插件還提供了在每一幀後或按鍵壓下或滑鼠點擊後執行自定義事件處理代码的功能(請注意, 每一幀後的代碼執行會使期間字段中的 'keypress' 選項失效; 但仍然可以聽到該 Escape 按鈕壓下)。例如, 如果所有希望計算参與者在電影放映時間內按下空格鍵(或任何其他按鍵)的次數，這將非常有用。

在此輸入的腳本中可以獲得一些變量：

- `continue_playback` (True 或 False) - 是繼續播放電影。當電影正在播放時，此變量默認設定為 True。如果你想從你的腳本停止播放，只需將此變量設定為 False，播放將停止。
- `exp` - 一個指向 self.experiment 物件的變量
- `frame` - 正在顯示的當前畫面的數字
- `mov_width` - 電影寬度，以像素為單位
- `mov_height` - 電影高度，以像素為單位
- `paused` - *True* 當播放當前停止, *False* 當電影正在進行
- `event` - 這個變量有些特殊，因為它的內容依賴於最後一幀的時間是否有鍵或滑鼠按鈕被壓下。如果不是這種情況，事件變量將只指向 *None*。如果有鍵被壓下，事件將包含一個元組，在該元組的第一個位置是 "key" 的值，在該元組的第二個位置是被壓下的鍵的值，例如 ("key","space")。如果有滑鼠按鈕被點擊，事件變量將包含一個元組，在該元組的第一個位置是 "mouse" 的值，並在該元組的第二個位置是被點擊的滑鼠按鈕的數字，例如 ("mouse", 2)。剛好在一個幀時間內有多個按鈕或鍵被壓下的罕見情況，事件變量將包含這些事件的裏表，例如 [("key","space"),("key", "x"),("mouse",2)]。在這種情況下, 你需要在你的腳本中遍歷這個陣列並拉出所有你覺得相關的事件。

你也有以下功能可以使用：

- `pause()` - 當電影正在進行時暫停播放，否則恢復播放 (你可以認為它是暫停/取消暫停切換)

[opensesame]: http://www.cogsci.nl/opensesame
[mpy_home]: http://zulko.github.io/moviepy/