# 基于MoviePy的媒体播放器插件

版权 2010-2016 Daniel Schreij (<d.schreij@vu.nl>)

media_player_mpy 插件为[OpenSesame实验构建器][opensesame]添加了视频播放功能。此插件以[Moviepy][mpy_home]为基础。它应能够处理大多数现代视频和音频格式，尽管重要的是他们的流不被损坏。如果文件似乎无法工作，请尝试查找更好的版本，或尝试将其重新编码成不同的格式。

通过使用硬件加速的Psychopy或Expyriment后端，可以实现最好的播放。当使用遗留和电影分辨率或帧率较高时，性能可能会不足。

## 插件设置
该插件从GUI提供以下配置选项：

- *视频文件* - 要播放的视频文件。此字段允许像[video_file]这样的变量表示法，您可以在循环项中指定其值。
- *播放音频* - 指定是否应播放带有音频的视频或静音（静音）。
- *适应屏幕的视频* - 指定视频是否应以其原始大小播放，或者是否应调整其大小以适应窗口/屏幕的大小。重新调整大小的过程将保持电影的原始宽高比。
- *循环* - 指定视频是否应循环播放，这意味着一旦电影结束，它将从头开始。
- *持续时间* - 指定电影应显示多长时间。预期的值是秒，'keypress'或'mouseclick'。如果它是最后的值之一，当按键被按下或点击鼠标按钮时，播放将停止。

## 自定义Python代码以处理按键和鼠标点击事件
此插件还提供了在每个帧后，或按键或鼠标点击后执行自定义事件处理代码的功能（注意，每个帧后的代码执行将使持续时间字段中的'keypress'选项失效；然而，仍会侦听Escape按键）。这在某种情况下是有用的，例如，如果某人想数一数参与者在电影放映期间按下空格（或任何其他按钮）的次数。

在您在这里输入的脚本中有几个可以访问的变量：

- `continue_playback`（真或假） - 确定电影是否应继续播放。默认情况下，当电影正在播放时，此变量设置为True。如果你想从你的脚本停止播放，只需将此变量设置为False，播放就会停止。
- `exp` - 一个指向self.experiment对象的便捷变量
- `frame` - 当前正在显示的帧的编号
- `mov_width` - 电影的宽度（以px为单位）
- `mov_height` - 电影的高度（以px为单位）
- `paused` - 当播放当前已暂停时为*True*，如果电影目前正在播放则为*False*
- `event` - 这个变量有点特殊，因为其内容取决于上一帧期间是否按下了键或鼠标按钮。如果不是这种情况，事件变量将简单地指向*None*。如果按下了一个键，则事件将包含一个元组，在第一个位置出现“键”的值，在第二个位置出现被按下的键的值，例如（"key","space"）。如果点击了鼠标按钮，事件变量将包含一个元组，在第一个位置处的值为"mouse"，在第二个位置处的值为被点击的鼠标按钮的编号，例如（"mouse", 2）。在极少数情况下，如果在一帧期间同时按下了多个按钮或键，事件变量将包含这些事件的列表，例如[("key","space"),("key", "x"),("mouse",2)]。在这种情况下，你将需要在你的代码中遍历这个列表，并抽出所有对你有用的事件。

除了这些变量外，你还可以使用以下函数：

- `pause()` - 当电影正在播放时暂停播放，否则解暂停（你可以将其视为暂停/解暂停切换）

[opensesame]: http://www.cogsci.nl/opensesame
[mpy_home]: http://zulko.github.io/moviepy/